import n, { forwardRef as ae, useRef as P, useContext as ne, useEffect as le } from "react";
import d from "../../../classnames/index.mjs";
import "../../../rc-input/node_modules/classnames/index.mjs";
import ie from "../../../rc-input/es/Input.mjs";
import { composeRef as ue } from "../../../rc-util/es/ref.mjs";
import { getStatusClassNames as R, getMergedStatus as ce } from "../_util/statusUtils.mjs";
import { devUseWarning as V } from "../_util/warning.mjs";
import "../config-provider/index.mjs";
import de from "../config-provider/DisabledContext.mjs";
import me from "../config-provider/hooks/useSize.mjs";
import { FormItemInputContext as fe, NoFormStyle as z } from "../form/context.mjs";
import { useCompactItemContext as pe, NoCompactStyle as B } from "../space/Compact.mjs";
import ge from "./hooks/useRemovePasswordTimeout.mjs";
import ve from "./style/index.mjs";
import { hasPrefixSuffix as Ce } from "./utils.mjs";
import be from "../config-provider/hooks/useCSSVarCls.mjs";
import xe from "../form/hooks/useVariants.mjs";
import we from "../_util/getAllowClear.mjs";
import { ConfigContext as Se } from "../config-provider/context.mjs";
var ye = globalThis && globalThis.__rest || function(e, i) {
  var a = {};
  for (var r in e)
    Object.prototype.hasOwnProperty.call(e, r) && i.indexOf(r) < 0 && (a[r] = e[r]);
  if (e != null && typeof Object.getOwnPropertySymbols == "function")
    for (var l = 0, r = Object.getOwnPropertySymbols(e); l < r.length; l++)
      i.indexOf(r[l]) < 0 && Object.prototype.propertyIsEnumerable.call(e, r[l]) && (a[r[l]] = e[r[l]]);
  return a;
};
function Me(e, i) {
  if (!e)
    return;
  e.focus(i);
  const {
    cursor: a
  } = i || {};
  if (a) {
    const r = e.value.length;
    switch (a) {
      case "start":
        e.setSelectionRange(0, 0);
        break;
      case "end":
        e.setSelectionRange(r, r);
        break;
      default:
        e.setSelectionRange(0, r);
        break;
    }
  }
}
const Ne = /* @__PURE__ */ ae((e, i) => {
  var a;
  const {
    prefixCls: r,
    bordered: l = !0,
    status: k,
    size: C,
    disabled: b,
    onBlur: x,
    onFocus: w,
    suffix: h,
    allowClear: A,
    addonAfter: O,
    addonBefore: $,
    className: D,
    style: T,
    styles: W,
    rootClassName: H,
    onChange: S,
    classNames: f,
    variant: M
  } = e, Q = ye(e, ["prefixCls", "bordered", "status", "size", "disabled", "onBlur", "onFocus", "suffix", "allowClear", "addonAfter", "addonBefore", "className", "style", "styles", "rootClassName", "onChange", "classNames", "variant"]);
  if (process.env.NODE_ENV !== "production") {
    const {
      deprecated: s
    } = V("Input");
    s(!("bordered" in e), "bordered", "variant");
  }
  const {
    getPrefixCls: U,
    direction: m,
    input: t
  } = n.useContext(Se), o = U("input", r), y = P(null), E = be(o), [q, p, G] = ve(o, E), {
    compactSize: J,
    compactItemClassnames: K
  } = pe(o, m), c = me((s) => {
    var u;
    return (u = C ?? J) !== null && u !== void 0 ? u : s;
  }), L = n.useContext(de), X = b ?? L, {
    status: Y,
    hasFeedback: g,
    feedbackIcon: Z
  } = ne(fe), I = ce(Y, k), v = Ce(e) || !!g, j = P(v);
  if (process.env.NODE_ENV !== "production") {
    const s = V("Input");
    le(() => {
      var u;
      v && !j.current && process.env.NODE_ENV !== "production" && s(document.activeElement === ((u = y.current) === null || u === void 0 ? void 0 : u.input), "usage", "When Input is focused, dynamic add or remove prefix / suffix will make it lose focus caused by dom structure change. Read more: https://ant.design/components/input/#FAQ"), j.current = v;
    }, [v]);
  }
  const N = ge(y, !0), ee = (s) => {
    N(), x == null || x(s);
  }, te = (s) => {
    N(), w == null || w(s);
  }, oe = (s) => {
    N(), S == null || S(s);
  }, re = (g || h) && /* @__PURE__ */ n.createElement(n.Fragment, null, h, g && Z), se = we(A), [_, F] = xe(M, l);
  return q(/* @__PURE__ */ n.createElement(ie, Object.assign({
    ref: ue(i, y),
    prefixCls: o,
    autoComplete: t == null ? void 0 : t.autoComplete
  }, Q, {
    disabled: X,
    onBlur: ee,
    onFocus: te,
    style: Object.assign(Object.assign({}, t == null ? void 0 : t.style), T),
    styles: Object.assign(Object.assign({}, t == null ? void 0 : t.styles), W),
    suffix: re,
    allowClear: se,
    className: d(D, H, G, E, K, t == null ? void 0 : t.className),
    onChange: oe,
    addonAfter: O && /* @__PURE__ */ n.createElement(B, null, /* @__PURE__ */ n.createElement(z, {
      override: !0,
      status: !0
    }, O)),
    addonBefore: $ && /* @__PURE__ */ n.createElement(B, null, /* @__PURE__ */ n.createElement(z, {
      override: !0,
      status: !0
    }, $)),
    classNames: Object.assign(Object.assign(Object.assign({}, f), t == null ? void 0 : t.classNames), {
      input: d({
        [`${o}-sm`]: c === "small",
        [`${o}-lg`]: c === "large",
        [`${o}-rtl`]: m === "rtl"
      }, f == null ? void 0 : f.input, (a = t == null ? void 0 : t.classNames) === null || a === void 0 ? void 0 : a.input, p),
      variant: d({
        [`${o}-${_}`]: F
      }, R(o, I)),
      affixWrapper: d({
        [`${o}-affix-wrapper-sm`]: c === "small",
        [`${o}-affix-wrapper-lg`]: c === "large",
        [`${o}-affix-wrapper-rtl`]: m === "rtl"
      }, p),
      wrapper: d({
        [`${o}-group-rtl`]: m === "rtl"
      }, p),
      groupWrapper: d({
        [`${o}-group-wrapper-sm`]: c === "small",
        [`${o}-group-wrapper-lg`]: c === "large",
        [`${o}-group-wrapper-rtl`]: m === "rtl",
        [`${o}-group-wrapper-${_}`]: F
      }, R(`${o}-group-wrapper`, I, g), p)
    })
  })));
}), Qe = Ne;
export {
  Qe as default,
  Me as triggerFocus
};
