import "../../../../@ant-design/cssinjs/es/extractStyle.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import { unit as n } from "../../../../@ant-design/cssinjs/es/util/index.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import { resetComponent as l, clearFix as g } from "../../style/index.mjs";
import { genCompactItemStyle as $ } from "../../style/compact-item.mjs";
import { genStyleHooks as b } from "../../theme/util/genComponentStyleHook.mjs";
import { merge as h } from "../../theme/util/statistic.mjs";
import { initInputToken as m, initComponentToken as f } from "./token.mjs";
import { genOutlinedStyle as S, genFilledStyle as x, genBorderlessStyle as R, genOutlinedGroupStyle as I, genFilledGroupStyle as E } from "./variants.mjs";
const w = (r) => ({
  // Firefox
  "&::-moz-placeholder": {
    opacity: 1
  },
  "&::placeholder": {
    color: r,
    userSelect: "none"
    // https://github.com/ant-design/ant-design/pull/32639
  },
  "&:placeholder-shown": {
    textOverflow: "ellipsis"
  }
}), s = (r) => {
  const {
    paddingBlockLG: i,
    lineHeightLG: e,
    borderRadiusLG: t,
    paddingInlineLG: o
  } = r;
  return {
    padding: `${n(i)} ${n(o)}`,
    fontSize: r.inputFontSizeLG,
    lineHeight: e,
    borderRadius: t
  };
}, c = (r) => ({
  padding: `${n(r.paddingBlockSM)} ${n(r.paddingInlineSM)}`,
  fontSize: r.inputFontSizeSM,
  borderRadius: r.borderRadiusSM
}), p = (r) => Object.assign(Object.assign({
  position: "relative",
  display: "inline-block",
  width: "100%",
  minWidth: 0,
  padding: `${n(r.paddingBlock)} ${n(r.paddingInline)}`,
  color: r.colorText,
  fontSize: r.inputFontSize,
  lineHeight: r.lineHeight,
  borderRadius: r.borderRadius,
  transition: `all ${r.motionDurationMid}`
}, w(r.colorTextPlaceholder)), {
  // Reset height for `textarea`s
  "textarea&": {
    maxWidth: "100%",
    // prevent textarea resize from coming out of its container
    height: "auto",
    minHeight: r.controlHeight,
    lineHeight: r.lineHeight,
    verticalAlign: "bottom",
    transition: `all ${r.motionDurationSlow}, height 0s`,
    resize: "vertical"
  },
  // Size
  "&-lg": Object.assign({}, s(r)),
  "&-sm": Object.assign({}, c(r)),
  // RTL
  "&-rtl": {
    direction: "rtl"
  },
  "&-textarea-rtl": {
    direction: "rtl"
  }
}), y = (r) => {
  const {
    componentCls: i,
    antCls: e
  } = r;
  return {
    position: "relative",
    display: "table",
    width: "100%",
    borderCollapse: "separate",
    borderSpacing: 0,
    // Undo padding and float of grid classes
    "&[class*='col-']": {
      paddingInlineEnd: r.paddingXS,
      "&:last-child": {
        paddingInlineEnd: 0
      }
    },
    // Sizing options
    [`&-lg ${i}, &-lg > ${i}-group-addon`]: Object.assign({}, s(r)),
    [`&-sm ${i}, &-sm > ${i}-group-addon`]: Object.assign({}, c(r)),
    // Fix https://github.com/ant-design/ant-design/issues/5754
    [`&-lg ${e}-select-single ${e}-select-selector`]: {
      height: r.controlHeightLG
    },
    [`&-sm ${e}-select-single ${e}-select-selector`]: {
      height: r.controlHeightSM
    },
    [`> ${i}`]: {
      display: "table-cell",
      "&:not(:first-child):not(:last-child)": {
        borderRadius: 0
      }
    },
    [`${i}-group`]: {
      "&-addon, &-wrap": {
        display: "table-cell",
        width: 1,
        whiteSpace: "nowrap",
        verticalAlign: "middle",
        "&:not(:first-child):not(:last-child)": {
          borderRadius: 0
        }
      },
      "&-wrap > *": {
        display: "block !important"
      },
      "&-addon": {
        position: "relative",
        padding: `0 ${n(r.paddingInline)}`,
        color: r.colorText,
        fontWeight: "normal",
        fontSize: r.inputFontSize,
        textAlign: "center",
        borderRadius: r.borderRadius,
        transition: `all ${r.motionDurationSlow}`,
        lineHeight: 1,
        // Reset Select's style in addon
        [`${e}-select`]: {
          margin: `${n(r.calc(r.paddingBlock).add(1).mul(-1).equal())} ${n(r.calc(r.paddingInline).mul(-1).equal())}`,
          [`&${e}-select-single:not(${e}-select-customize-input):not(${e}-pagination-size-changer)`]: {
            [`${e}-select-selector`]: {
              backgroundColor: "inherit",
              border: `${n(r.lineWidth)} ${r.lineType} transparent`,
              boxShadow: "none"
            }
          },
          "&-open, &-focused": {
            [`${e}-select-selector`]: {
              color: r.colorPrimary
            }
          }
        },
        // https://github.com/ant-design/ant-design/issues/31333
        [`${e}-cascader-picker`]: {
          margin: `-9px ${n(r.calc(r.paddingInline).mul(-1).equal())}`,
          backgroundColor: "transparent",
          [`${e}-cascader-input`]: {
            textAlign: "start",
            border: 0,
            boxShadow: "none"
          }
        }
      }
    },
    [`${i}`]: {
      width: "100%",
      marginBottom: 0,
      textAlign: "inherit",
      "&:focus": {
        zIndex: 1,
        // Fix https://gw.alipayobjects.com/zos/rmsportal/DHNpoqfMXSfrSnlZvhsJ.png
        borderInlineEndWidth: 1
      },
      "&:hover": {
        zIndex: 1,
        borderInlineEndWidth: 1,
        [`${i}-search-with-button &`]: {
          zIndex: 0
        }
      }
    },
    // Reset rounded corners
    [`> ${i}:first-child, ${i}-group-addon:first-child`]: {
      borderStartEndRadius: 0,
      borderEndEndRadius: 0,
      // Reset Select's style in addon
      [`${e}-select ${e}-select-selector`]: {
        borderStartEndRadius: 0,
        borderEndEndRadius: 0
      }
    },
    [`> ${i}-affix-wrapper`]: {
      [`&:not(:first-child) ${i}`]: {
        borderStartStartRadius: 0,
        borderEndStartRadius: 0
      },
      [`&:not(:last-child) ${i}`]: {
        borderStartEndRadius: 0,
        borderEndEndRadius: 0
      }
    },
    [`> ${i}:last-child, ${i}-group-addon:last-child`]: {
      borderStartStartRadius: 0,
      borderEndStartRadius: 0,
      // Reset Select's style in addon
      [`${e}-select ${e}-select-selector`]: {
        borderStartStartRadius: 0,
        borderEndStartRadius: 0
      }
    },
    [`${i}-affix-wrapper`]: {
      "&:not(:last-child)": {
        borderStartEndRadius: 0,
        borderEndEndRadius: 0,
        [`${i}-search &`]: {
          borderStartStartRadius: r.borderRadius,
          borderEndStartRadius: r.borderRadius
        }
      },
      [`&:not(:first-child), ${i}-search &:not(:first-child)`]: {
        borderStartStartRadius: 0,
        borderEndStartRadius: 0
      }
    },
    [`&${i}-group-compact`]: Object.assign(Object.assign({
      display: "block"
    }, g()), {
      [`${i}-group-addon, ${i}-group-wrap, > ${i}`]: {
        "&:not(:first-child):not(:last-child)": {
          borderInlineEndWidth: r.lineWidth,
          "&:hover": {
            zIndex: 1
          },
          "&:focus": {
            zIndex: 1
          }
        }
      },
      "& > *": {
        display: "inline-block",
        float: "none",
        verticalAlign: "top",
        // https://github.com/ant-design/ant-design-pro/issues/139
        borderRadius: 0
      },
      [`
        & > ${i}-affix-wrapper,
        & > ${i}-number-affix-wrapper,
        & > ${e}-picker-range
      `]: {
        display: "inline-flex"
      },
      "& > *:not(:last-child)": {
        marginInlineEnd: r.calc(r.lineWidth).mul(-1).equal(),
        borderInlineEndWidth: r.lineWidth
      },
      // Undo float for .ant-input-group .ant-input
      [`${i}`]: {
        float: "none"
      },
      // reset border for Select, DatePicker, AutoComplete, Cascader, Mention, TimePicker, Input
      [`& > ${e}-select > ${e}-select-selector,
      & > ${e}-select-auto-complete ${i},
      & > ${e}-cascader-picker ${i},
      & > ${i}-group-wrapper ${i}`]: {
        borderInlineEndWidth: r.lineWidth,
        borderRadius: 0,
        "&:hover": {
          zIndex: 1
        },
        "&:focus": {
          zIndex: 1
        }
      },
      [`& > ${e}-select-focused`]: {
        zIndex: 1
      },
      // update z-index for arrow icon
      [`& > ${e}-select > ${e}-select-arrow`]: {
        zIndex: 1
        // https://github.com/ant-design/ant-design/issues/20371
      },
      [`& > *:first-child,
      & > ${e}-select:first-child > ${e}-select-selector,
      & > ${e}-select-auto-complete:first-child ${i},
      & > ${e}-cascader-picker:first-child ${i}`]: {
        borderStartStartRadius: r.borderRadius,
        borderEndStartRadius: r.borderRadius
      },
      [`& > *:last-child,
      & > ${e}-select:last-child > ${e}-select-selector,
      & > ${e}-cascader-picker:last-child ${i},
      & > ${e}-cascader-picker-focused:last-child ${i}`]: {
        borderInlineEndWidth: r.lineWidth,
        borderStartEndRadius: r.borderRadius,
        borderEndEndRadius: r.borderRadius
      },
      // https://github.com/ant-design/ant-design/issues/12493
      [`& > ${e}-select-auto-complete ${i}`]: {
        verticalAlign: "top"
      },
      [`${i}-group-wrapper + ${i}-group-wrapper`]: {
        marginInlineStart: r.calc(r.lineWidth).mul(-1).equal(),
        [`${i}-affix-wrapper`]: {
          borderRadius: 0
        }
      },
      [`${i}-group-wrapper:not(:last-child)`]: {
        [`&${i}-search > ${i}-group`]: {
          [`& > ${i}-group-addon > ${i}-search-button`]: {
            borderRadius: 0
          },
          [`& > ${i}`]: {
            borderStartStartRadius: r.borderRadius,
            borderStartEndRadius: 0,
            borderEndEndRadius: 0,
            borderEndStartRadius: r.borderRadius
          }
        }
      }
    })
  };
}, v = (r) => {
  const {
    componentCls: i,
    controlHeightSM: e,
    lineWidth: t,
    calc: o
  } = r, d = 16, a = o(e).sub(o(t).mul(2)).sub(d).div(2).equal();
  return {
    [i]: Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, l(r)), p(r)), S(r)), x(r)), R(r)), {
      '&[type="color"]': {
        height: r.controlHeight,
        [`&${i}-lg`]: {
          height: r.controlHeightLG
        },
        [`&${i}-sm`]: {
          height: e,
          paddingTop: a,
          paddingBottom: a
        }
      },
      '&[type="search"]::-webkit-search-cancel-button, &[type="search"]::-webkit-search-decoration': {
        "-webkit-appearance": "none"
      }
    })
  };
}, z = (r) => {
  const {
    componentCls: i
  } = r;
  return {
    // ========================= Input =========================
    [`${i}-clear-icon`]: {
      margin: 0,
      color: r.colorTextQuaternary,
      fontSize: r.fontSizeIcon,
      verticalAlign: -1,
      // https://github.com/ant-design/ant-design/pull/18151
      // https://codesandbox.io/s/wizardly-sun-u10br
      cursor: "pointer",
      transition: `color ${r.motionDurationSlow}`,
      "&:hover": {
        color: r.colorTextTertiary
      },
      "&:active": {
        color: r.colorText
      },
      "&-hidden": {
        visibility: "hidden"
      },
      "&-has-suffix": {
        margin: `0 ${n(r.inputAffixPadding)}`
      }
    }
  };
}, O = (r) => {
  const {
    componentCls: i,
    inputAffixPadding: e,
    colorTextDescription: t,
    motionDurationSlow: o,
    colorIcon: d,
    colorIconHover: a,
    iconCls: u
  } = r;
  return {
    [`${i}-affix-wrapper`]: Object.assign(Object.assign(Object.assign(Object.assign({}, p(r)), {
      display: "inline-flex",
      [`&:not(${i}-disabled):hover`]: {
        zIndex: 1,
        [`${i}-search-with-button &`]: {
          zIndex: 0
        }
      },
      "&-focused, &:focus": {
        zIndex: 1
      },
      [`> input${i}`]: {
        padding: 0,
        fontSize: "inherit",
        border: "none",
        borderRadius: 0,
        outline: "none",
        background: "transparent",
        color: "inherit",
        "&::-ms-reveal": {
          display: "none"
        },
        "&:focus": {
          boxShadow: "none !important"
        }
      },
      "&::before": {
        display: "inline-block",
        width: 0,
        visibility: "hidden",
        content: '"\\a0"'
      },
      [`${i}`]: {
        "&-prefix, &-suffix": {
          display: "flex",
          flex: "none",
          alignItems: "center",
          "> *:not(:last-child)": {
            marginInlineEnd: r.paddingXS
          }
        },
        "&-show-count-suffix": {
          color: t
        },
        "&-show-count-has-suffix": {
          marginInlineEnd: r.paddingXXS
        },
        "&-prefix": {
          marginInlineEnd: e
        },
        "&-suffix": {
          marginInlineStart: e
        }
      }
    }), z(r)), {
      // password
      [`${u}${i}-password-icon`]: {
        color: d,
        cursor: "pointer",
        transition: `all ${o}`,
        "&:hover": {
          color: a
        }
      }
    })
  };
}, H = (r) => {
  const {
    componentCls: i,
    borderRadiusLG: e,
    borderRadiusSM: t
  } = r;
  return {
    [`${i}-group`]: Object.assign(Object.assign(Object.assign({}, l(r)), y(r)), {
      "&-rtl": {
        direction: "rtl"
      },
      "&-wrapper": Object.assign(Object.assign(Object.assign({
        display: "inline-block",
        width: "100%",
        textAlign: "start",
        verticalAlign: "top",
        "&-rtl": {
          direction: "rtl"
        },
        // Size
        "&-lg": {
          [`${i}-group-addon`]: {
            borderRadius: e,
            fontSize: r.inputFontSizeLG
          }
        },
        "&-sm": {
          [`${i}-group-addon`]: {
            borderRadius: t
          }
        }
      }, I(r)), E(r)), {
        // '&-disabled': {
        //   [`${componentCls}-group-addon`]: {
        //     ...genDisabledStyle(token),
        //   },
        // },
        // Fix the issue of using icons in Space Compact mode
        // https://github.com/ant-design/ant-design/issues/42122
        [`&:not(${i}-compact-first-item):not(${i}-compact-last-item)${i}-compact-item`]: {
          [`${i}, ${i}-group-addon`]: {
            borderRadius: 0
          }
        },
        [`&:not(${i}-compact-last-item)${i}-compact-first-item`]: {
          [`${i}, ${i}-group-addon`]: {
            borderStartEndRadius: 0,
            borderEndEndRadius: 0
          }
        },
        [`&:not(${i}-compact-first-item)${i}-compact-last-item`]: {
          [`${i}, ${i}-group-addon`]: {
            borderStartStartRadius: 0,
            borderEndStartRadius: 0
          }
        }
      })
    })
  };
}, C = (r) => {
  const {
    componentCls: i,
    antCls: e
  } = r, t = `${i}-search`;
  return {
    [t]: {
      [`${i}`]: {
        "&:hover, &:focus": {
          borderColor: r.colorPrimaryHover,
          [`+ ${i}-group-addon ${t}-button:not(${e}-btn-primary)`]: {
            borderInlineStartColor: r.colorPrimaryHover
          }
        }
      },
      [`${i}-affix-wrapper`]: {
        borderRadius: 0
      },
      // fix slight height diff in Firefox:
      // https://ant.design/components/auto-complete-cn/#components-auto-complete-demo-certain-category
      [`${i}-lg`]: {
        lineHeight: r.calc(r.lineHeightLG).sub(2e-4).equal({
          unit: !1
        })
      },
      [`> ${i}-group`]: {
        [`> ${i}-group-addon:last-child`]: {
          insetInlineStart: -1,
          padding: 0,
          border: 0,
          [`${t}-button`]: {
            paddingTop: 0,
            paddingBottom: 0,
            borderStartStartRadius: 0,
            borderStartEndRadius: r.borderRadius,
            borderEndEndRadius: r.borderRadius,
            borderEndStartRadius: 0,
            boxShadow: "none"
          },
          [`${t}-button:not(${e}-btn-primary)`]: {
            color: r.colorTextDescription,
            "&:hover": {
              color: r.colorPrimaryHover
            },
            "&:active": {
              color: r.colorPrimaryActive
            },
            [`&${e}-btn-loading::before`]: {
              insetInlineStart: 0,
              insetInlineEnd: 0,
              insetBlockStart: 0,
              insetBlockEnd: 0
            }
          }
        }
      },
      [`${t}-button`]: {
        height: r.controlHeight,
        "&:hover, &:focus": {
          zIndex: 1
        }
      },
      [`&-large ${t}-button`]: {
        height: r.controlHeightLG
      },
      [`&-small ${t}-button`]: {
        height: r.controlHeightSM
      },
      "&-rtl": {
        direction: "rtl"
      },
      // ===================== Compact Item Customized Styles =====================
      [`&${i}-compact-item`]: {
        [`&:not(${i}-compact-last-item)`]: {
          [`${i}-group-addon`]: {
            [`${i}-search-button`]: {
              marginInlineEnd: r.calc(r.lineWidth).mul(-1).equal(),
              borderRadius: 0
            }
          }
        },
        [`&:not(${i}-compact-first-item)`]: {
          [`${i},${i}-affix-wrapper`]: {
            borderRadius: 0
          }
        },
        [`> ${i}-group-addon ${i}-search-button,
        > ${i},
        ${i}-affix-wrapper`]: {
          "&:hover,&:focus,&:active": {
            zIndex: 2
          }
        },
        [`> ${i}-affix-wrapper-focused`]: {
          zIndex: 2
        }
      }
    }
  };
}, j = (r) => {
  const {
    componentCls: i,
    paddingLG: e
  } = r, t = `${i}-textarea`;
  return {
    [t]: {
      position: "relative",
      "&-show-count": {
        // https://github.com/ant-design/ant-design/issues/33049
        [`> ${i}`]: {
          height: "100%"
        },
        [`${i}-data-count`]: {
          position: "absolute",
          bottom: r.calc(r.fontSize).mul(r.lineHeight).mul(-1).equal(),
          insetInlineEnd: 0,
          color: r.colorTextDescription,
          whiteSpace: "nowrap",
          pointerEvents: "none"
        }
      },
      "&-allow-clear": {
        [`> ${i}`]: {
          paddingInlineEnd: e
        }
      },
      [`&-affix-wrapper${t}-has-feedback`]: {
        [`${i}`]: {
          paddingInlineEnd: e
        }
      },
      [`&-affix-wrapper${i}-affix-wrapper`]: {
        padding: 0,
        [`> textarea${i}`]: {
          fontSize: "inherit",
          border: "none",
          outline: "none",
          background: "transparent",
          "&:focus": {
            boxShadow: "none !important"
          }
        },
        [`${i}-suffix`]: {
          margin: 0,
          "> *:not(:last-child)": {
            marginInline: 0
          },
          // Clear Icon
          [`${i}-clear-icon`]: {
            position: "absolute",
            insetInlineEnd: r.paddingXS,
            insetBlockStart: r.paddingXS
          },
          // Feedback Icon
          [`${t}-suffix`]: {
            position: "absolute",
            top: 0,
            insetInlineEnd: r.paddingInline,
            bottom: 0,
            zIndex: 1,
            display: "inline-flex",
            alignItems: "center",
            margin: "auto",
            pointerEvents: "none"
          }
        }
      }
    }
  };
}, T = (r) => {
  const {
    componentCls: i
  } = r;
  return {
    [`${i}-out-of-range`]: {
      [`&, & input, & textarea, ${i}-show-count-suffix, ${i}-data-count`]: {
        color: r.colorError
      }
    }
  };
}, Z = b("Input", (r) => {
  const i = h(r, m(r));
  return [
    v(i),
    j(i),
    O(i),
    H(i),
    C(i),
    T(i),
    // =====================================================
    // ==             Space Compact                       ==
    // =====================================================
    $(i)
  ];
}, f);
export {
  Z as default,
  p as genBasicInputStyle,
  y as genInputGroupStyle,
  c as genInputSmallStyle,
  w as genPlaceholderStyle,
  f as initComponentToken,
  m as initInputToken
};
