import "../../../../@ant-design/cssinjs/es/extractStyle.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import { unit as m } from "../../../../@ant-design/cssinjs/es/util/index.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import { clearFix as M, resetComponent as E, resetIcon as X } from "../../style/index.mjs";
import { initSlideMotion as O } from "../../style/motion/slide.mjs";
import { initZoomMotion as q } from "../../style/motion/zoom.mjs";
import G from "../../style/motion/collapse.mjs";
import { genStyleHooks as P } from "../../theme/util/genComponentStyleHook.mjs";
import { merge as R } from "../../theme/util/statistic.mjs";
import F from "./horizontal.mjs";
import Y from "./rtl.mjs";
import j from "./theme.mjs";
import _ from "./vertical.mjs";
import { TinyColor as k } from "../../../../@ctrl/tinycolor/dist/module/index.mjs";
const W = (t) => {
  const {
    componentCls: r,
    motionDurationSlow: e,
    motionDurationMid: l,
    motionEaseInOut: o,
    motionEaseOut: i,
    iconCls: n,
    iconSize: d,
    iconMarginInlineEnd: c
  } = t;
  return {
    // >>>>> Item
    [`${r}-item, ${r}-submenu-title`]: {
      position: "relative",
      display: "block",
      margin: 0,
      whiteSpace: "nowrap",
      cursor: "pointer",
      transition: [`border-color ${e}`, `background ${e}`, `padding ${e} ${o}`].join(","),
      [`${r}-item-icon, ${n}`]: {
        minWidth: d,
        fontSize: d,
        transition: [`font-size ${l} ${i}`, `margin ${e} ${o}`, `color ${e}`].join(","),
        "+ span": {
          marginInlineStart: c,
          opacity: 1,
          transition: [`opacity ${e} ${o}`, `margin ${e}`, `color ${e}`].join(",")
        }
      },
      [`${r}-item-icon`]: Object.assign({}, X()),
      [`&${r}-item-only-child`]: {
        [`> ${n}, > ${r}-item-icon`]: {
          marginInlineEnd: 0
        }
      }
    },
    // Disabled state sets text to gray and nukes hover/tab effects
    [`${r}-item-disabled, ${r}-submenu-disabled`]: {
      background: "none !important",
      cursor: "not-allowed",
      "&::after": {
        borderColor: "transparent !important"
      },
      a: {
        color: "inherit !important"
      },
      [`> ${r}-submenu-title`]: {
        color: "inherit !important",
        cursor: "not-allowed"
      }
    }
  };
}, L = (t) => {
  const {
    componentCls: r,
    motionDurationSlow: e,
    motionEaseInOut: l,
    borderRadius: o,
    menuArrowSize: i,
    menuArrowOffset: n
  } = t;
  return {
    [`${r}-submenu`]: {
      "&-expand-icon, &-arrow": {
        position: "absolute",
        top: "50%",
        insetInlineEnd: t.margin,
        width: i,
        color: "currentcolor",
        transform: "translateY(-50%)",
        transition: `transform ${e} ${l}, opacity ${e}`
      },
      "&-arrow": {
        // →
        "&::before, &::after": {
          position: "absolute",
          width: t.calc(i).mul(0.6).equal(),
          height: t.calc(i).mul(0.15).equal(),
          backgroundColor: "currentcolor",
          borderRadius: o,
          transition: [`background ${e} ${l}`, `transform ${e} ${l}`, `top ${e} ${l}`, `color ${e} ${l}`].join(","),
          content: '""'
        },
        "&::before": {
          transform: `rotate(45deg) translateY(${m(t.calc(n).mul(-1).equal())})`
        },
        "&::after": {
          transform: `rotate(-45deg) translateY(${m(n)})`
        }
      }
    }
  };
}, V = (t) => {
  const {
    antCls: r,
    componentCls: e,
    fontSize: l,
    motionDurationSlow: o,
    motionDurationMid: i,
    motionEaseInOut: n,
    paddingXS: d,
    padding: c,
    colorSplit: b,
    lineWidth: u,
    zIndexPopup: B,
    borderRadiusLG: S,
    subMenuItemBorderRadius: p,
    menuArrowSize: $,
    menuArrowOffset: g,
    lineType: h,
    menuPanelMaskInset: s,
    groupTitleLineHeight: f,
    groupTitleFontSize: v
  } = t;
  return [
    // Misc
    {
      "": {
        [`${e}`]: Object.assign(Object.assign({}, M()), {
          // Hidden
          "&-hidden": {
            display: "none"
          }
        })
      },
      [`${e}-submenu-hidden`]: {
        display: "none"
      }
    },
    {
      [e]: Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, E(t)), M()), {
        marginBottom: 0,
        paddingInlineStart: 0,
        // Override default ul/ol
        fontSize: l,
        lineHeight: 0,
        listStyle: "none",
        outline: "none",
        // Magic cubic here but smooth transition
        transition: `width ${o} cubic-bezier(0.2, 0, 0, 1) 0s`,
        "ul, ol": {
          margin: 0,
          padding: 0,
          listStyle: "none"
        },
        // Overflow ellipsis
        "&-overflow": {
          display: "flex",
          [`${e}-item`]: {
            flex: "none"
          }
        },
        [`${e}-item, ${e}-submenu, ${e}-submenu-title`]: {
          borderRadius: t.itemBorderRadius
        },
        [`${e}-item-group-title`]: {
          padding: `${m(d)} ${m(c)}`,
          fontSize: v,
          lineHeight: f,
          transition: `all ${o}`
        },
        [`&-horizontal ${e}-submenu`]: {
          transition: [`border-color ${o} ${n}`, `background ${o} ${n}`].join(",")
        },
        [`${e}-submenu, ${e}-submenu-inline`]: {
          transition: [`border-color ${o} ${n}`, `background ${o} ${n}`, `padding ${i} ${n}`].join(",")
        },
        [`${e}-submenu ${e}-sub`]: {
          cursor: "initial",
          transition: [`background ${o} ${n}`, `padding ${o} ${n}`].join(",")
        },
        [`${e}-title-content`]: {
          transition: `color ${o}`,
          // https://github.com/ant-design/ant-design/issues/41143
          [`> ${r}-typography-ellipsis-single-line`]: {
            display: "inline",
            verticalAlign: "unset"
          }
        },
        [`${e}-item a`]: {
          "&::before": {
            position: "absolute",
            inset: 0,
            backgroundColor: "transparent",
            content: '""'
          }
        },
        // Removed a Badge related style seems it's safe
        // https://github.com/ant-design/ant-design/issues/19809
        // >>>>> Divider
        [`${e}-item-divider`]: {
          overflow: "hidden",
          lineHeight: 0,
          borderColor: b,
          borderStyle: h,
          borderWidth: 0,
          borderTopWidth: u,
          marginBlock: u,
          padding: 0,
          "&-dashed": {
            borderStyle: "dashed"
          }
        }
      }), W(t)), {
        [`${e}-item-group`]: {
          [`${e}-item-group-list`]: {
            margin: 0,
            padding: 0,
            [`${e}-item, ${e}-submenu-title`]: {
              paddingInline: `${m(t.calc(l).mul(2).equal())} ${m(c)}`
            }
          }
        },
        // ======================= Sub Menu =======================
        "&-submenu": {
          "&-popup": {
            position: "absolute",
            zIndex: B,
            borderRadius: S,
            boxShadow: "none",
            transformOrigin: "0 0",
            [`&${e}-submenu`]: {
              background: "transparent"
            },
            // https://github.com/ant-design/ant-design/issues/13955
            "&::before": {
              position: "absolute",
              inset: `${m(s)} 0 0`,
              zIndex: -1,
              width: "100%",
              height: "100%",
              opacity: 0,
              content: '""'
            }
          },
          // https://github.com/ant-design/ant-design/issues/13955
          "&-placement-rightTop::before": {
            top: 0,
            insetInlineStart: s
          },
          "\n          &-placement-leftTop,\n          &-placement-bottomRight,\n          ": {
            transformOrigin: "100% 0"
          },
          "\n          &-placement-leftBottom,\n          &-placement-topRight,\n          ": {
            transformOrigin: "100% 100%"
          },
          "\n          &-placement-rightBottom,\n          &-placement-topLeft,\n          ": {
            transformOrigin: "0 100%"
          },
          "\n          &-placement-bottomLeft,\n          &-placement-rightTop,\n          ": {
            transformOrigin: "0 0"
          },
          "\n          &-placement-leftTop,\n          &-placement-leftBottom\n          ": {
            paddingInlineEnd: t.paddingXS
          },
          "\n          &-placement-rightTop,\n          &-placement-rightBottom\n          ": {
            paddingInlineStart: t.paddingXS
          },
          "\n          &-placement-topRight,\n          &-placement-topLeft\n          ": {
            paddingBottom: t.paddingXS
          },
          "\n          &-placement-bottomRight,\n          &-placement-bottomLeft\n          ": {
            paddingTop: t.paddingXS
          },
          [`> ${e}`]: Object.assign(Object.assign(Object.assign({
            borderRadius: S
          }, W(t)), L(t)), {
            [`${e}-item, ${e}-submenu > ${e}-submenu-title`]: {
              borderRadius: p
            },
            [`${e}-submenu-title::after`]: {
              transition: `transform ${o} ${n}`
            }
          })
        }
      }), L(t)), {
        [`&-inline-collapsed ${e}-submenu-arrow,
        &-inline ${e}-submenu-arrow`]: {
          // ↓
          "&::before": {
            transform: `rotate(-45deg) translateX(${m(g)})`
          },
          "&::after": {
            transform: `rotate(45deg) translateX(${m(t.calc(g).mul(-1).equal())})`
          }
        },
        [`${e}-submenu-open${e}-submenu-inline > ${e}-submenu-title > ${e}-submenu-arrow`]: {
          // ↑
          transform: `translateY(${m(t.calc($).mul(0.2).mul(-1).equal())})`,
          "&::after": {
            transform: `rotate(-45deg) translateX(${m(t.calc(g).mul(-1).equal())})`
          },
          "&::before": {
            transform: `rotate(45deg) translateX(${m(g)})`
          }
        }
      })
    },
    // Integration with header element so menu items have the same height
    {
      [`${r}-layout-header`]: {
        [e]: {
          lineHeight: "inherit"
        }
      }
    }
  ];
}, Z = (t) => {
  var r, e, l;
  const {
    colorPrimary: o,
    colorError: i,
    colorTextDisabled: n,
    colorErrorBg: d,
    colorText: c,
    colorTextDescription: b,
    colorBgContainer: u,
    colorFillAlter: B,
    colorFillContent: S,
    lineWidth: p,
    lineWidthBold: $,
    controlItemBgActive: g,
    colorBgTextHover: h,
    controlHeightLG: s,
    lineHeight: f,
    colorBgElevated: v,
    marginXXS: z,
    padding: x,
    fontSize: C,
    controlHeightSM: D,
    fontSizeLG: y,
    colorTextLightSolid: I,
    colorErrorHover: H
  } = t, a = (r = t.activeBarWidth) !== null && r !== void 0 ? r : 0, T = (e = t.activeBarBorderWidth) !== null && e !== void 0 ? e : p, w = (l = t.itemMarginInline) !== null && l !== void 0 ? l : t.marginXXS, A = new k(I).setAlpha(0.65).toRgbString();
  return {
    dropdownWidth: 160,
    zIndexPopup: t.zIndexPopupBase + 50,
    radiusItem: t.borderRadiusLG,
    itemBorderRadius: t.borderRadiusLG,
    radiusSubMenuItem: t.borderRadiusSM,
    subMenuItemBorderRadius: t.borderRadiusSM,
    colorItemText: c,
    itemColor: c,
    colorItemTextHover: c,
    itemHoverColor: c,
    colorItemTextHoverHorizontal: o,
    horizontalItemHoverColor: o,
    colorGroupTitle: b,
    groupTitleColor: b,
    colorItemTextSelected: o,
    itemSelectedColor: o,
    colorItemTextSelectedHorizontal: o,
    horizontalItemSelectedColor: o,
    colorItemBg: u,
    itemBg: u,
    colorItemBgHover: h,
    itemHoverBg: h,
    colorItemBgActive: S,
    itemActiveBg: g,
    colorSubItemBg: B,
    subMenuItemBg: B,
    colorItemBgSelected: g,
    itemSelectedBg: g,
    colorItemBgSelectedHorizontal: "transparent",
    horizontalItemSelectedBg: "transparent",
    colorActiveBarWidth: 0,
    activeBarWidth: a,
    colorActiveBarHeight: $,
    activeBarHeight: $,
    colorActiveBarBorderSize: p,
    activeBarBorderWidth: T,
    // Disabled
    colorItemTextDisabled: n,
    itemDisabledColor: n,
    // Danger
    colorDangerItemText: i,
    dangerItemColor: i,
    colorDangerItemTextHover: i,
    dangerItemHoverColor: i,
    colorDangerItemTextSelected: i,
    dangerItemSelectedColor: i,
    colorDangerItemBgActive: d,
    dangerItemActiveBg: d,
    colorDangerItemBgSelected: d,
    dangerItemSelectedBg: d,
    itemMarginInline: w,
    horizontalItemBorderRadius: 0,
    horizontalItemHoverBg: "transparent",
    itemHeight: s,
    groupTitleLineHeight: f,
    collapsedWidth: s * 2,
    popupBg: v,
    itemMarginBlock: z,
    itemPaddingInline: x,
    horizontalLineHeight: `${s * 1.15}px`,
    iconSize: C,
    iconMarginInlineEnd: D - C,
    collapsedIconSize: y,
    groupTitleFontSize: C,
    // Disabled
    darkItemDisabledColor: new k(I).setAlpha(0.25).toRgbString(),
    // Dark
    darkItemColor: A,
    darkDangerItemColor: i,
    darkItemBg: "#001529",
    darkPopupBg: "#001529",
    darkSubMenuItemBg: "#000c17",
    darkItemSelectedColor: I,
    darkItemSelectedBg: o,
    darkDangerItemSelectedBg: i,
    darkItemHoverBg: "transparent",
    darkGroupTitleColor: A,
    darkItemHoverColor: I,
    darkDangerItemHoverColor: H,
    darkDangerItemSelectedColor: I,
    darkDangerItemActiveBg: i,
    // internal
    itemWidth: a ? `calc(100% + ${T}px)` : `calc(100% - ${w * 2}px)`
  };
}, Se = function(t) {
  let r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : t, e = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : !0;
  return P("Menu", (o) => {
    const {
      colorBgElevated: i,
      colorPrimary: n,
      colorTextLightSolid: d,
      controlHeightLG: c,
      fontSize: b,
      darkItemColor: u,
      darkDangerItemColor: B,
      darkItemBg: S,
      darkSubMenuItemBg: p,
      darkItemSelectedColor: $,
      darkItemSelectedBg: g,
      darkDangerItemSelectedBg: h,
      darkItemHoverBg: s,
      darkGroupTitleColor: f,
      darkItemHoverColor: v,
      darkItemDisabledColor: z,
      darkDangerItemHoverColor: x,
      darkDangerItemSelectedColor: C,
      darkDangerItemActiveBg: D,
      popupBg: y,
      darkPopupBg: I
    } = o, H = o.calc(b).div(7).mul(5).equal(), a = R(o, {
      menuArrowSize: H,
      menuHorizontalHeight: o.calc(c).mul(1.15).equal(),
      menuArrowOffset: o.calc(H).mul(0.25).equal(),
      menuPanelMaskInset: -7,
      // Still a hardcode here since it's offset by rc-align
      menuSubMenuBg: i,
      calc: o.calc,
      popupBg: y
    }), T = R(a, {
      itemColor: u,
      itemHoverColor: v,
      groupTitleColor: f,
      itemSelectedColor: $,
      itemBg: S,
      popupBg: I,
      subMenuItemBg: p,
      itemActiveBg: "transparent",
      itemSelectedBg: g,
      activeBarHeight: 0,
      activeBarBorderWidth: 0,
      itemHoverBg: s,
      // Disabled
      itemDisabledColor: z,
      // Danger
      dangerItemColor: B,
      dangerItemHoverColor: x,
      dangerItemSelectedColor: C,
      dangerItemActiveBg: D,
      dangerItemSelectedBg: h,
      menuSubMenuBg: p,
      // Horizontal
      horizontalItemSelectedColor: d,
      horizontalItemSelectedBg: n
    });
    return [
      // Basic
      V(a),
      // Horizontal
      F(a),
      // Hard code for some light style
      // Vertical
      _(a),
      // Hard code for some light style
      // Theme
      j(a, "light"),
      j(T, "dark"),
      // RTL
      Y(a),
      // Motion
      G(a),
      O(a, "slide-up"),
      O(a, "slide-down"),
      q(a, "zoom-big")
    ];
  }, Z, {
    deprecatedTokens: [["colorGroupTitle", "groupTitleColor"], ["radiusItem", "itemBorderRadius"], ["radiusSubMenuItem", "subMenuItemBorderRadius"], ["colorItemText", "itemColor"], ["colorItemTextHover", "itemHoverColor"], ["colorItemTextHoverHorizontal", "horizontalItemHoverColor"], ["colorItemTextSelected", "itemSelectedColor"], ["colorItemTextSelectedHorizontal", "horizontalItemSelectedColor"], ["colorItemTextDisabled", "itemDisabledColor"], ["colorDangerItemText", "dangerItemColor"], ["colorDangerItemTextHover", "dangerItemHoverColor"], ["colorDangerItemTextSelected", "dangerItemSelectedColor"], ["colorDangerItemBgActive", "dangerItemActiveBg"], ["colorDangerItemBgSelected", "dangerItemSelectedBg"], ["colorItemBg", "itemBg"], ["colorItemBgHover", "itemHoverBg"], ["colorSubItemBg", "subMenuItemBg"], ["colorItemBgActive", "itemActiveBg"], ["colorItemBgSelectedHorizontal", "horizontalItemSelectedBg"], ["colorActiveBarWidth", "activeBarWidth"], ["colorActiveBarHeight", "activeBarHeight"], ["colorActiveBarBorderSize", "activeBarBorderWidth"], ["colorItemBgSelected", "itemSelectedBg"]],
    // Dropdown will handle menu style self. We do not need to handle this.
    injectStyle: e,
    unitless: {
      groupTitleLineHeight: !0
    }
  })(t, r);
};
export {
  Se as default,
  Z as prepareComponentToken
};
