import { resetComponent as p, textEllipsis as c } from "../../style/index.mjs";
import { initMoveMotion as l } from "../../style/motion/move.mjs";
import { slideUpIn as g, slideDownIn as u, slideUpOut as b, slideDownOut as $, initSlideMotion as s } from "../../style/motion/slide.mjs";
const m = (o) => {
  const {
    optionHeight: i,
    optionFontSize: n,
    optionLineHeight: e,
    optionPadding: d
  } = o;
  return {
    position: "relative",
    display: "block",
    minHeight: i,
    padding: d,
    color: o.colorText,
    fontWeight: "normal",
    fontSize: n,
    lineHeight: e,
    boxSizing: "border-box"
  };
}, S = (o) => {
  const {
    antCls: i,
    componentCls: n
  } = o, e = `${n}-item`, d = `&${i}-slide-up-enter${i}-slide-up-enter-active`, a = `&${i}-slide-up-appear${i}-slide-up-appear-active`, r = `&${i}-slide-up-leave${i}-slide-up-leave-active`, t = `${n}-dropdown-placement-`;
  return [
    {
      [`${n}-dropdown`]: Object.assign(Object.assign({}, p(o)), {
        position: "absolute",
        top: -9999,
        zIndex: o.zIndexPopup,
        boxSizing: "border-box",
        padding: o.paddingXXS,
        overflow: "hidden",
        fontSize: o.fontSize,
        // Fix select render lag of long text in chrome
        // https://github.com/ant-design/ant-design/issues/11456
        // https://github.com/ant-design/ant-design/issues/11843
        fontVariant: "initial",
        backgroundColor: o.colorBgElevated,
        borderRadius: o.borderRadiusLG,
        outline: "none",
        boxShadow: o.boxShadowSecondary,
        [`
          ${d}${t}bottomLeft,
          ${a}${t}bottomLeft
        `]: {
          animationName: g
        },
        [`
          ${d}${t}topLeft,
          ${a}${t}topLeft,
          ${d}${t}topRight,
          ${a}${t}topRight
        `]: {
          animationName: u
        },
        [`${r}${t}bottomLeft`]: {
          animationName: b
        },
        [`
          ${r}${t}topLeft,
          ${r}${t}topRight
        `]: {
          animationName: $
        },
        "&-hidden": {
          display: "none"
        },
        [`${e}`]: Object.assign(Object.assign({}, m(o)), {
          cursor: "pointer",
          transition: `background ${o.motionDurationSlow} ease`,
          borderRadius: o.borderRadiusSM,
          // =========== Group ============
          "&-group": {
            color: o.colorTextDescription,
            fontSize: o.fontSizeSM,
            cursor: "default"
          },
          // =========== Option ===========
          "&-option": {
            display: "flex",
            "&-content": Object.assign({
              flex: "auto"
            }, c),
            "&-state": {
              flex: "none",
              display: "flex",
              alignItems: "center"
            },
            [`&-active:not(${e}-option-disabled)`]: {
              backgroundColor: o.optionActiveBg
            },
            [`&-selected:not(${e}-option-disabled)`]: {
              color: o.optionSelectedColor,
              fontWeight: o.optionSelectedFontWeight,
              backgroundColor: o.optionSelectedBg,
              [`${e}-option-state`]: {
                color: o.colorPrimary
              },
              [`&:has(+ ${e}-option-selected:not(${e}-option-disabled))`]: {
                borderEndStartRadius: 0,
                borderEndEndRadius: 0,
                [`& + ${e}-option-selected:not(${e}-option-disabled)`]: {
                  borderStartStartRadius: 0,
                  borderStartEndRadius: 0
                }
              }
            },
            "&-disabled": {
              [`&${e}-option-selected`]: {
                backgroundColor: o.colorBgContainerDisabled
              },
              color: o.colorTextDisabled,
              cursor: "not-allowed"
            },
            "&-grouped": {
              paddingInlineStart: o.calc(o.controlPaddingHorizontal).mul(2).equal()
            }
          }
        }),
        // =========================== RTL ===========================
        "&-rtl": {
          direction: "rtl"
        }
      })
    },
    // Follow code may reuse in other components
    s(o, "slide-up"),
    s(o, "slide-down"),
    l(o, "move-up"),
    l(o, "move-down")
  ];
}, h = S;
export {
  h as default
};
